diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
index a3b0c5c11..949369358 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFire.java
@@ -1,22 +1,23 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.weather.IPrecipitation;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
@@ -35,7 +36,7 @@ public class BlockLogicFire
     private static final int @NotNull [] burnChance = new int[Blocks.blocksList.length];
 
     public BlockLogicFire(final @NotNull Block<?> block) {
-        super(block, Material.fire);
+        super(block, Materials.FIRE);
         block.setTicking(true);
         this.setBlockBounds(0.0f, 0.0f, 0.0f, 1.0f, 1.0f, 1.0f);
     }
@@ -88,7 +89,7 @@ public class BlockLogicFire
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return null;
     }
 
@@ -103,14 +104,14 @@ public class BlockLogicFire
     }
 
     @Override
-    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public @NotNull ISupport getSupport(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
     @Override
-    public void onRemoved(final @NotNull World world, final @NotNull TilePos tilePos, final int data) {
+    public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
         for (int i = 0; i < 8; i++) {
-            world.spawnParticle("largesmoke", tilePos.x + Math.random(), tilePos.y + 0.5D, tilePos.z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
+            world.spawnParticle("largesmoke", tilePos.x() + Math.random(), tilePos.y() + 0.5D, tilePos.z() + Math.random(), 0.0D, 0.0D, 0.0D, 0);
         }
     }
 
@@ -119,27 +120,28 @@ public class BlockLogicFire
         return 40;
     }
 
-    public void setBurnResult(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public void setBurnResult(final @NotNull World world, final @NotNull TilePosc tilePos) {
         world.setBlockIdNotify(tilePos, this.getBurnResultId(world, tilePos));
     }
 
     @Override
-    public void updateTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand, final boolean isRandomTick) {
-        final @Nullable Block<?> blockUnder = world.getBlock(tilePos.down());
+    public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
+        TilePos queryPos = new TilePos();
+
+        final @Nullable Block<?> blockUnder = world.getBlock(tilePos.down(queryPos));
         final boolean infiniBurn = blockUnder != null && blockUnder.hasTag(BlockTags.INFINITE_BURN);
 
         // Extinguish fire
         if (!this.isValidFireLocation(world, tilePos)) {
             this.setBurnResult(world, tilePos);
         }
-
         // Extinguish fire (Rain / Snow)
         if (!infiniBurn && world.getCurrentWeather() != null && world.getCurrentWeather() instanceof IPrecipitation && (
             world.isBlockBeingRainedOn(tilePos)
-                || world.isBlockBeingRainedOn(tilePos.west())
-                || world.isBlockBeingRainedOn(tilePos.east())
-                || world.isBlockBeingRainedOn(tilePos.north())
-                || world.isBlockBeingRainedOn(tilePos.south()))) {
+                || world.isBlockBeingRainedOn(tilePos.west(queryPos))
+                || world.isBlockBeingRainedOn(tilePos.east(queryPos))
+                || world.isBlockBeingRainedOn(tilePos.north(queryPos))
+                || world.isBlockBeingRainedOn(tilePos.south(queryPos)))) {
             this.setBurnResult(world, tilePos);
             return;
         }
@@ -152,35 +154,35 @@ public class BlockLogicFire
 
 
         if (!infiniBurn && !this.canNeighborCatchFire(world, tilePos)) {
-            if (!world.isBlockNormalCube(tilePos.down()) || meta > 3) {
+            if (!world.isBlockNormalCube(tilePos.down(queryPos)) || meta > 3) {
                 this.setBurnResult(world, tilePos);
             }
             return;
         }
 
-        if (!infiniBurn && !canBurn(world, tilePos.down()) && meta == 15 && rand.nextInt(4) == 0) {
+        if (!infiniBurn && !canBurn(world, tilePos.down(queryPos)) && meta == 15 && rand.nextInt(4) == 0) {
             this.setBurnResult(world, tilePos);
             return;
         }
 
-        this.checkBurn(world, tilePos.east(), 300, rand, meta);
-        this.checkBurn(world, tilePos.west(), 300, rand, meta);
-        this.checkBurn(world, tilePos.down(), 250, rand, meta);
-        this.checkBurn(world, tilePos.up(), 250, rand, meta);
-        this.checkBurn(world, tilePos.north(), 300, rand, meta);
-        this.checkBurn(world, tilePos.south(), 300, rand, meta);
+        this.checkBurn(world, tilePos.east(queryPos), 300, rand, meta);
+        this.checkBurn(world, tilePos.west(queryPos), 300, rand, meta);
+        this.checkBurn(world, tilePos.down(queryPos), 250, rand, meta);
+        this.checkBurn(world, tilePos.up(queryPos), 250, rand, meta);
+        this.checkBurn(world, tilePos.north(queryPos), 300, rand, meta);
+        this.checkBurn(world, tilePos.south(queryPos), 300, rand, meta);
 
         final @NotNull TilePos localPos = new TilePos(tilePos);
-        for (localPos.x = tilePos.x - 1; localPos.x <= tilePos.x + 1; localPos.x++) {
-            for (localPos.z = tilePos.z - 1; localPos.z <= tilePos.z + 1; localPos.z++) {
-                for (localPos.y = tilePos.y - 1; localPos.y <= tilePos.y + 4; localPos.y++) {
+        for (localPos.x = tilePos.x() - 1; localPos.x <= tilePos.x() + 1; localPos.x++) {
+            for (localPos.z = tilePos.z() - 1; localPos.z <= tilePos.z() + 1; localPos.z++) {
+                for (localPos.y = tilePos.y() - 1; localPos.y <= tilePos.y() + 4; localPos.y++) {
                     if (localPos.equals(tilePos)) {
                         continue;
                     }
 
                     int a = 100;
-                    if (localPos.y > tilePos.y + 1) {
-                        a += (localPos.y - (tilePos.y + 1)) * 100;
+                    if (localPos.y > tilePos.y() + 1) {
+                        a += (localPos.y - (tilePos.y() + 1)) * 100;
                     }
                     final int b = this.getFireChance(world, localPos);
                     if (b <= 0) {
@@ -190,10 +192,10 @@ public class BlockLogicFire
                     final int c = (b + 40) / (meta + 30);
                     if (c <= 0 || rand.nextInt(a) > c || (world.getCurrentWeather() != null && world.getCurrentWeather() instanceof IPrecipitation) &&
                         world.isBlockBeingRainedOn(localPos)
-                        || world.isBlockBeingRainedOn(localPos.west())
-                        || world.isBlockBeingRainedOn(localPos.east())
-                        || world.isBlockBeingRainedOn(localPos.north())
-                        || world.isBlockBeingRainedOn(localPos.south())
+                        || world.isBlockBeingRainedOn(localPos.west(queryPos))
+                        || world.isBlockBeingRainedOn(localPos.east(queryPos))
+                        || world.isBlockBeingRainedOn(localPos.north(queryPos))
+                        || world.isBlockBeingRainedOn(localPos.south(queryPos))
                     ) {
                         continue;
                     }
@@ -227,31 +229,33 @@ public class BlockLogicFire
         }
     }
 
-    protected boolean canNeighborCatchFire(final @NotNull World world, final @NotNull TilePos tilePos) {
-        if (canBurn(world, tilePos.east())) return true;
-        if (canBurn(world, tilePos.west())) return true;
-        if (canBurn(world, tilePos.down())) return true;
-        if (canBurn(world, tilePos.up())) return true;
-        if (canBurn(world, tilePos.north())) return true;
-        return canBurn(world, tilePos.south());
+    protected boolean canNeighborCatchFire(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
+        if (canBurn(world, tilePos.east(queryPos))) return true;
+        if (canBurn(world, tilePos.west(queryPos))) return true;
+        if (canBurn(world, tilePos.down(queryPos))) return true;
+        if (canBurn(world, tilePos.up(queryPos))) return true;
+        if (canBurn(world, tilePos.north(queryPos))) return true;
+        return canBurn(world, tilePos.south(queryPos));
     }
 
-    private int getFireChance(final @NotNull World world, final @NotNull TilePos tilePos) {
+    private int getFireChance(final @NotNull World world, final @NotNull TilePosc tilePos) {
         int flammability = 0;
         if (!world.isAirBlock(tilePos)) {
             return 0;
         } else {
-            flammability = getFlammability(world, tilePos.east(), flammability);
-            flammability = getFlammability(world, tilePos.west(), flammability);
-            flammability = getFlammability(world, tilePos.down(), flammability);
-            flammability = getFlammability(world, tilePos.up(), flammability);
-            flammability = getFlammability(world, tilePos.north(), flammability);
-            flammability = getFlammability(world, tilePos.south(), flammability);
+            TilePos queryPos = new TilePos();
+            flammability = getFlammability(world, tilePos.east(queryPos), flammability);
+            flammability = getFlammability(world, tilePos.west(queryPos), flammability);
+            flammability = getFlammability(world, tilePos.down(queryPos), flammability);
+            flammability = getFlammability(world, tilePos.up(queryPos), flammability);
+            flammability = getFlammability(world, tilePos.north(queryPos), flammability);
+            flammability = getFlammability(world, tilePos.south(queryPos), flammability);
             return flammability;
         }
     }
 
-    public static boolean canBurn(final @NotNull WorldSource source, final @NotNull TilePos tilePos) {
+    public static boolean canBurn(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
         return flameChance[source.getBlockId(tilePos)] > 0;
     }
 
@@ -259,29 +263,29 @@ public class BlockLogicFire
         return flameChance[blockId] > 0;
     }
 
-    public static int getFlammability(final @NotNull World world, final @NotNull TilePos tilePos, final int currentFlameChance) {
+    public static int getFlammability(final @NotNull World world, final @NotNull TilePosc tilePos, final int currentFlameChance) {
         final int blockFlameChance = flameChance[world.getBlockId(tilePos)];
         return Math.max(blockFlameChance, currentFlameChance);
     }
 
-    public boolean isValidFireLocation(final @NotNull World world, final @NotNull TilePos tilePos) {
-        return world.isBlockNormalCube(tilePos.down()) || this.canNeighborCatchFire(world, tilePos);
+    public boolean isValidFireLocation(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        return world.isBlockNormalCube(tilePos.down(new TilePos())) || this.canNeighborCatchFire(world, tilePos);
     }
 
     @Override
-    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePos tilePos) {
+    public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
         return this.isValidFireLocation(world, tilePos);
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePos tilePos, final int id) {
-        if (!world.isBlockNormalCube(tilePos.down()) && !this.canNeighborCatchFire(world, tilePos)) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
+        if (!world.isBlockNormalCube(tilePos.down(new TilePos())) && !this.canNeighborCatchFire(world, tilePos)) {
 
             world.setBlockIdNotify(tilePos, this.getBurnResultId(world, tilePos));
         }
     }
 
-    protected int getBurnResultId(final @NotNull World world, final @NotNull TilePos tilePos) {
+    protected int getBurnResultId(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final int id = world.getBlockId(tilePos);
         final @Nullable Block<?> stoneBlock = BlockLogicMoss.getStoneBlock(id);
         if (stoneBlock != null) {
@@ -291,11 +295,12 @@ public class BlockLogicFire
     }
 
     @Override
-    public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePos tilePos) {
-        if (world.getBlockId(tilePos.down()) == Blocks.OBSIDIAN.id() && Blocks.PORTAL_NETHER.getLogic().tryToCreatePortal(world, tilePos, null)) {
+    public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
+        if (world.getBlockId(tilePos.down(queryPos)) == Blocks.OBSIDIAN.id() && Blocks.PORTAL_NETHER.getLogic().tryToCreatePortal(world, tilePos, null)) {
             return;
         }
-        if (!world.isBlockNormalCube(tilePos.down()) && !this.canNeighborCatchFire(world, tilePos)) {
+        if (!world.isBlockNormalCube(tilePos.down(queryPos)) && !this.canNeighborCatchFire(world, tilePos)) {
             world.setBlockIdNotify(tilePos, this.getBurnResultId(world, tilePos));
         } else {
             world.scheduleBlockUpdate(tilePos, this.block.id(), this.tickDelay());
@@ -303,58 +308,59 @@ public class BlockLogicFire
     }
 
     @Override
-    public void animationTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand) {
+    public void animationTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand) {
         if (rand.nextInt(24) == 0) {
-            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x + 0.5F, tilePos.y + 0.5F, tilePos.z + 0.5F, "fire.fire",
+            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5F, tilePos.y() + 0.5F, tilePos.z() + 0.5F, "fire.fire",
                 1.0F + rand.nextFloat(), rand.nextFloat() * 0.7F + 0.3F);
         }
-        if (world.isBlockNormalCube(tilePos.down()) || canBurn(world, tilePos.down())) {
+        TilePos queryPos = new TilePos();
+        if (world.isBlockNormalCube(tilePos.down(queryPos)) || canBurn(world, tilePos.down(queryPos))) {
             for (int l = 0; l < 3; l++) {
-                final double x = tilePos.x + rand.nextFloat();
-                final double y = tilePos.y + rand.nextFloat() * 0.5F + 0.5F;
-                final double z = tilePos.z + rand.nextFloat();
+                final double x = tilePos.x() + rand.nextFloat();
+                final double y = tilePos.y() + rand.nextFloat() * 0.5F + 0.5F;
+                final double z = tilePos.z() + rand.nextFloat();
                 world.spawnParticle("largesmoke", x, y, z, 0.0D, 0.0D, 0.0D, 0);
             }
 
         } else {
-            if (canBurn(world, tilePos.west())) {
+            if (canBurn(world, tilePos.west(queryPos))) {
                 for (int i = 0; i < 2; i++) {
-                    final double x = tilePos.x + rand.nextFloat() * 0.1F;
-                    final double y = tilePos.y + rand.nextFloat();
-                    final double z = tilePos.z + rand.nextFloat();
+                    final double x = tilePos.x() + rand.nextFloat() * 0.1F;
+                    final double y = tilePos.y() + rand.nextFloat();
+                    final double z = tilePos.z() + rand.nextFloat();
                     world.spawnParticle("largesmoke", x, y, z, 0.0D, 0.0D, 0.0D, 0);
                 }
             }
-            if (canBurn(world, tilePos.east())) {
+            if (canBurn(world, tilePos.east(queryPos))) {
                 for (int i = 0; i < 2; i++) {
-                    final double x = (tilePos.x + 1) - rand.nextFloat() * 0.1F;
-                    final double y = tilePos.y + rand.nextFloat();
-                    final double z = tilePos.z + rand.nextFloat();
+                    final double x = (tilePos.x() + 1) - rand.nextFloat() * 0.1F;
+                    final double y = tilePos.y() + rand.nextFloat();
+                    final double z = tilePos.z() + rand.nextFloat();
                     world.spawnParticle("largesmoke", x, y, z, 0.0D, 0.0D, 0.0D, 0);
                 }
             }
-            if (canBurn(world, tilePos.north())) {
+            if (canBurn(world, tilePos.north(queryPos))) {
                 for (int i = 0; i < 2; i++) {
-                    final double x = tilePos.x + rand.nextFloat();
-                    final double y = tilePos.y + rand.nextFloat();
-                    final double z = tilePos.z + rand.nextFloat() * 0.1F;
+                    final double x = tilePos.x() + rand.nextFloat();
+                    final double y = tilePos.y() + rand.nextFloat();
+                    final double z = tilePos.z() + rand.nextFloat() * 0.1F;
                     world.spawnParticle("largesmoke", x, y, z, 0.0D, 0.0D, 0.0D, 0);
                 }
             }
-            if (canBurn(world, tilePos.south())) {
+            if (canBurn(world, tilePos.south(queryPos))) {
                 for (int i = 0; i < 2; i++) {
-                    final double x = tilePos.x + rand.nextFloat();
-                    final double y = tilePos.y + rand.nextFloat();
-                    final double z = (tilePos.z + 1) - rand.nextFloat() * 0.1F;
+                    final double x = tilePos.x() + rand.nextFloat();
+                    final double y = tilePos.y() + rand.nextFloat();
+                    final double z = (tilePos.z() + 1) - rand.nextFloat() * 0.1F;
                     world.spawnParticle("largesmoke", x, y, z, 0.0D, 0.0D, 0.0D, 0);
                 }
 
             }
-            if (canBurn(world, tilePos.up())) {
+            if (canBurn(world, tilePos.up(queryPos))) {
                 for (int i = 0; i < 2; i++) {
-                    final double x = tilePos.x + rand.nextFloat();
-                    final double y = (tilePos.y + 1) - rand.nextFloat() * 0.1F;
-                    final double z = tilePos.z + rand.nextFloat();
+                    final double x = tilePos.x() + rand.nextFloat();
+                    final double y = (tilePos.y() + 1) - rand.nextFloat() * 0.1F;
+                    final double z = tilePos.z() + rand.nextFloat();
                     world.spawnParticle("largesmoke", x, y, z, 0.0D, 0.0D, 0.0D, 0);
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java
index 58c894cc4..8e98677c2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFireCold.java
@@ -1,9 +1,9 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.tag.BlockTags;
-import net.minecraft.core.data.gamerule.GameRules;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.weather.IPrecipitation;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -17,8 +17,9 @@ public class BlockLogicFireCold
     }
 
     @Override
-    public void updateTick(final @NotNull World world, final @NotNull TilePos tilePos, final @NotNull Random rand, final boolean isRandomTick) {
-        final @Nullable Block<?> blockUnder = world.getBlock(tilePos.down());
+    public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
+        TilePos queryPos = new TilePos();
+        final @Nullable Block<?> blockUnder = world.getBlock(tilePos.down(queryPos));
         final boolean infiniBurn = blockUnder != null && blockUnder.hasTag(BlockTags.INFINITE_BURN_COLD);
 
         // Extinguish fire
@@ -29,10 +30,10 @@ public class BlockLogicFireCold
         // Extinguish fire (Rain / Snow)
         if (!infiniBurn && world.getCurrentWeather() != null && world.getCurrentWeather() instanceof IPrecipitation && (
             world.isBlockBeingRainedOn(tilePos)
-                || world.isBlockBeingRainedOn(tilePos.west())
-                || world.isBlockBeingRainedOn(tilePos.east())
-                || world.isBlockBeingRainedOn(tilePos.north())
-                || world.isBlockBeingRainedOn(tilePos.south()))) {
+                || world.isBlockBeingRainedOn(tilePos.west(queryPos))
+                || world.isBlockBeingRainedOn(tilePos.east(queryPos))
+                || world.isBlockBeingRainedOn(tilePos.north(queryPos))
+                || world.isBlockBeingRainedOn(tilePos.south(queryPos)))) {
             this.setBurnResult(world, tilePos);
             return;
         }
@@ -45,13 +46,13 @@ public class BlockLogicFireCold
 
 
         if (!infiniBurn && !this.canNeighborCatchFire(world, tilePos)) {
-            if (!world.isBlockNormalCube(tilePos.down()) || meta > 3) {
+            if (!world.isBlockNormalCube(tilePos.down(queryPos)) || meta > 3) {
                 this.setBurnResult(world, tilePos);
             }
             return;
         }
 
-        if (!infiniBurn && !canBurn(world, tilePos.down()) && meta == 15 && rand.nextInt(4) == 0) {
+        if (!infiniBurn && !canBurn(world, tilePos.down(queryPos)) && meta == 15 && rand.nextInt(4) == 0) {
             this.setBurnResult(world, tilePos);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
index d9341a250..f6372241c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFlag.java
@@ -12,12 +12,12 @@ import net.minecraft.core.item.ItemStack;
 import com.mojang.nbt.tags.CompoundTag;
 
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 
 public class BlockLogicFlag extends BlockLogic {
 
@@ -30,7 +30,7 @@ public class BlockLogicFlag extends BlockLogic {
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return null;
     }
 
@@ -47,7 +47,7 @@ public class BlockLogicFlag extends BlockLogic {
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
@@ -65,7 +65,7 @@ public class BlockLogicFlag extends BlockLogic {
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         if (!world.isClientSide && world.getTileEntity(tilePos) instanceof TileEntityFlag flag) {
             if (flag.owner != null && !player.uuid.equals(flag.owner)) {
                 return false;
@@ -81,7 +81,7 @@ public class BlockLogicFlag extends BlockLogic {
     }
 
     @Override
-    public int getPistonPushReaction(@NotNull World world, @NotNull TilePos tilePos) {
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
 }
